package com.hl.demo;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.os.Bundle;
import android.os.Handler;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TextView;

import com.hoolai.access.open.fastaccess.channel.FastSdk;
import com.hoolai.access.open.fastaccess.channel.request.AccessActivityDataInfo;
import com.hoolai.access.open.fastaccess.channel.request.AccessActivityType;
import com.hoolai.access.open.fastaccess.channel.request.EventType;
import com.hoolai.access.open.fastaccess.channel.request.GoodsInfo;
import com.hoolai.access.open.fastaccess.channel.request.PayParams;
import com.hoolai.access.open.fastaccess.channel.request.PlayerInfo;
import com.hoolai.access.open.fastaccess.channel.result.InitResult;
import com.hoolai.access.open.fastaccess.channel.result.LoginResult;
import com.hoolai.access.open.fastaccess.interf.HLAccountListener;
import com.hoolai.access.open.fastaccess.interf.HLDeepLinkListener;
import com.hoolai.access.open.fastaccess.interf.HLPaymentListener;
import com.hoolai.access.open.fastaccess.interf.HLShareListener;
import com.hoolai.access.open.fastaccess.interf.HLSystemListener;
import com.hoolai.access.open.fastaccess.utils.Logger;
import com.hoolai.access.open.fastaccess.utils.ToastUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TODO: 接口文档：https://wanda.feishu.cn/wiki/wikcn3Ni4UhozeWsAGOus6szaGd
 * TODO: 数据上报文档： https://wanda.feishu.cn/wiki/wikcniSxQbyvqU3bzuXeOtpEcGc
 */
public class MainActivity extends Activity {

    private static final String TAG = "fastsdkdemo";
    private boolean isInit, isLogin;
    private TextView textView;
    private Button initBtn;
    private ScrollView scrollView;
    private LinearLayout linearLayout;
    private String str = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        textView = findViewById(R.id.textview);
        initBtn = findViewById(R.id.initBtn);
        scrollView = findViewById(R.id.scrollView);
        linearLayout = findViewById(R.id.linearLayout);
        setText("调用初始化");
        //先注册回调监听，再调用初始化
        registerListeners();
        FastSdk.onCreate(MainActivity.this);
    }

    private void registerListeners() {
        //TODO：系统回调监听（必接）
        FastSdk.hlSystemListener = new HLSystemListener() {
            @Override
            public void onInitSuccess(InitResult initResult) {
                isInit = true;
                Logger.data(TAG, "初始化成功");
                setText(">>初始化成功：" + initResult.toString());
                initBtn.setVisibility(View.GONE);
                //单个权限申请
                boolean hasPermission = FastSdk.checkPermission(MainActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
                //批量权限申请，showRefusedTip：拒绝后是否弹框提示（一般当拒绝权限会影响功能时设置为true）
//                boolean hasPermission = FastSdk.checkPermissions(MainActivity.this,
//                        new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.CAMERA},
//                        false);
                if (hasPermission) {
                    //TODO: your code
                }
            }

            @Override
            public void onInitFailed(String reason) {
                Logger.data(TAG, "初始化失败：" + reason);
                setText(">>初始化失败：" + reason);
                initBtn.setVisibility(View.VISIBLE);
            }

            @Override
            public void onCustomExit() {
                //需要自己创建退出界面
                Logger.data(TAG, "弹出游戏的退出界面");
                setText(">>弹出游戏的退出界面");
                new AlertDialog.Builder(MainActivity.this)
                        .setTitle("游戏退出弹窗")
                        .setMessage("我是游戏的弹窗界面哦")
                        .setNegativeButton("取消", null)
                        .setPositiveButton("确定", (dialog, which) -> onExitSuccess(""))
                        .setCancelable(false).show();
            }

            @Override
            public void onExitSuccess(String result) {
                //当前渠道如果有退出界面，触发该回调，开始处理退出逻辑
                moveTaskToBack(true);
                finish();
                //建议游戏按照下面代码逻辑，退出程序兼容性最好，否则可能会造成oppop、vivo等渠道退出不彻底，导致再次点击启动应用黑屏。
                Intent intent = new Intent(Intent.ACTION_MAIN);
                intent.addCategory(Intent.CATEGORY_HOME);
                intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                startActivity(intent);
                android.os.Process.killProcess(android.os.Process.myPid());
            }

            @Override
            public void onUpdate(String data) {
                Logger.data(TAG, "升级：" + data);
            }
        };
        //TODO：账号回调监听（必接）
        FastSdk.hlAccountListener = new HLAccountListener() {
            @Override
            public void onRefreshUser(LoginResult result) {
                //没有小号可忽略
            }

            @Override
            public void onLoginSuccess(LoginResult result) {
                Logger.data(TAG, "登录成功：" + result);
                setText(">>登录成功：" + result.toString());
                isLogin = true;
            }

            @Override
            public void onLoginFailed(String reason) {
                Logger.data(TAG, "登录失败:" + reason);
                setText(">>登录失败：" + reason);
            }

            @Override
            public void onLogout(Object... var1) {
                Logger.data(TAG, "已登出");
                setText(">>已登出");
                isLogin = false;
            }
        };
        //TODO：支付回调监听（必接）
        FastSdk.hlPaymentListener = new HLPaymentListener() {
            @Override
            public void onPaySuccess(String result) {
                Logger.data(TAG, "支付成功 " + result);
                setText(">>支付成功");
            }

            @Override
            public void onPayFailed(String reason) {
                Logger.data(TAG, "支付失败:" + reason);
                setText(">>支付失败：" + reason);
            }

            @Override
            public void onQuerySuccess(List<GoodsInfo> list) {
                Logger.data(TAG, "商品信息获取成功:" + list.toString());
                ProductUtils.showProducts(MainActivity.this, list);
                setText(">>商品信息获取成功");
            }
        };
        //TODO：如果没有分享功能可忽略
        FastSdk.hlShareListener = new HLShareListener() {
            @Override
            public void onShareSuccess() {

            }

            @Override
            public void onShareFailed(String s) {

            }
        };
        //TODO：如果没有Facebook的deeplink功能可忽略
        FastSdk.hlDeepLinkListener = new HLDeepLinkListener() {
            @Override
            public void onDeepLinkSuccess(String result) {
                HLDeepLinkListener.super.onDeepLinkSuccess(result);
            }
        };
    }

    public void init(View v) {
        setText("调用初始化");
        FastSdk.onCreate(this);
    }

    public void login(View v) {
        if (isInit) {
            setText("调用登录");
            FastSdk.login();
        } else {
            ToastUtils.toast("请先初始化");
        }
    }

    public void baseTrack(View v) {
        if (isLogin) {
            setText("创角，进服，升级报送");
            FastSdk.report(EventType.CreateRole, getPlayerInfo());
            FastSdk.report(EventType.EnterServer, getPlayerInfo());
            FastSdk.report(EventType.LevelUp, getPlayerInfo());
            setText(">>报送内容：" + getPlayerInfo());
        } else {
            loginFirst();
        }
    }

    public void customTrack(View v) {
        if (isInit) {
            setText("自定义报送");
            FastSdk.report(EventType.CustomerAction, getPlayerInfo());
            setText(">>报送内容：" + getPlayerInfo());
        } else {
            ToastUtils.toast("请先初始化");
        }
    }

    /**
     * 方舟报送-自定义报点
     * action：报点名称
     *
     * @param v
     */
    public void fangZhouReport(View v) {
        setText("方舟报送");
        String action = "game_xxx";
        Map<String, Object> hashMap = new HashMap<>();
        hashMap.put("xxx", 123);
        hashMap.put("ooo", "321");
        FastSdk.gameDataReport(action, hashMap);
    }

    public void logout(View v) {
        if (isLogin) {
            setText("调用登出");
            FastSdk.logout();
        } else {
            loginFirst();
        }
    }

    public void getPriceInfo(View v) {
        if (isLogin) {
            setText("查询商品");
            FastSdk.queryGoodsInfo();
        } else {
            loginFirst();
        }
    }

    public void doPay(View v) {
        if (isLogin) {
            int amount = 1;//单位：分
            String amountStr = ((EditText) findViewById(R.id.et_amount)).getText().toString();
            if (!TextUtils.isEmpty(amountStr)) {
                amount = Integer.parseInt(amountStr);
            }
            PayParams payParams = getPayParams(amount);
            setText("调用支付：" + payParams);
            FastSdk.pay(payParams);
        } else {
            loginFirst();
        }
    }

    public void exchange(View v) {
        String code = ((EditText) findViewById(R.id.et_code)).getText().toString();
        AccessActivityDataInfo info = new AccessActivityDataInfo();
        info.setCode(code);
        FastSdk.accessParticipate(AccessActivityType.CD_KEY, info);
    }

    public void exit(View v) {
        setText("调用退出");
        FastSdk.exit();
    }

    public void openAccountCenter(View v) {
        setText("打开用户中心");
        FastSdk.openAccountCenter(this);
    }

    public void openKeFu(View v) {
        setText("打开客服");
        FastSdk.openService(this);
    }

    public void share(View v) {
        ShareActivity.start(this);
    }


    //TODO +++++++++++++++++++++++++++++++++++生命周期方法接入start+++++++++++++++++++++++++++++++++++
    @Override
    protected void onSaveInstanceState(Bundle outState) {
        FastSdk.onSaveInstanceState(outState);
        super.onSaveInstanceState(outState);
    }

    @Override
    protected void onStart() {
        super.onStart();
        FastSdk.onStart(this);
    }

    @Override
    protected void onResume() {
        super.onResume();
        Logger.data(TAG, "游戏页面onResume");
        FastSdk.onResume(this);
    }

    @Override
    protected void onStop() {
        FastSdk.onStop(this);
        super.onStop();
    }

    @Override
    protected void onPause() {
        FastSdk.onPause(this);
        super.onPause();
    }

    @Override
    protected void onRestart() {
        super.onRestart();
        Logger.data(TAG, "游戏页面onRestart");
        FastSdk.onRestart(this);
    }

    @Override
    protected void onDestroy() {
        FastSdk.onDestroy(this);
        super.onDestroy();
    }

    @Override
    protected void onNewIntent(Intent intent) {
        FastSdk.onNewIntent(intent);
        super.onNewIntent(intent);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        Logger.i("MainActivity.onActivityResult");
        FastSdk.onActivityResult(this, requestCode, resultCode, data);
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        FastSdk.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == Math.abs(Manifest.permission.WRITE_EXTERNAL_STORAGE.hashCode())) {
            if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                Logger.i("权限已被允许");
                //your code
            } else {
                Logger.i("权限已被拒绝");
            }
        }
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        FastSdk.onConfigurationChanged(this, newConfig, getResources());
    }


    @Override
    public void onBackPressed() {
        setText("调用返回");
        FastSdk.exit();
    }

    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
        FastSdk.onRestoreInstanceState(savedInstanceState);
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);
        FastSdk.onWindowFocusChanged(hasFocus);
    }

    //TODO ++++++++++++++++++++++++++++++++++ 生命周期方法接入end +++++++++++++++++++++++++++++++++++


    private PlayerInfo getPlayerInfo() {
        PlayerInfo playerInfo = new PlayerInfo();
        playerInfo.setRoleId("1235761");//角色唯一标识id
        playerInfo.setRoleName("昵称2");
        playerInfo.setRoleLevel("11");
        playerInfo.setZoneId("100");
        playerInfo.setZoneName("华东大区");
        playerInfo.setServerId("100");
        playerInfo.setServerName("大唐战机");
        playerInfo.setBalance("66");
        playerInfo.setVip("1");
        playerInfo.setPartyName("帮派名称");
        playerInfo.setClassField("aaaa");
        //extra格式:key:value,key:value，需要探测的地址放到此参数中
        //注意：探测地址的冒号用@替换，key必须使用以下三个字段：gameResourceUrl/gameLoginServerUrl/gameServerUrl
        //TODO 详情:https://wanda.feishu.cn/wiki/wikcniSxQbyvqU3bzuXeOtpEcGc
        playerInfo.setExtra("a:arm,b:bom,gameResourceUrl:http@game1.com,gameLoginServerUrl:tcp@game2.com,gameServerUrl:https@game3.com");
        playerInfo.setPhylum("1");
        return playerInfo;
    }

    private PayParams getPayParams(int amount) {
        PayParams payParams = new PayParams();
        payParams.setItemId("aaa.bbb.cc");//商品，要保证游戏内各个商品唯一（可以不传）
        //ItemName要求：这些特殊符号都不要有: + % # “ & / ? $ ^ *:) \ < > , |。否则会造成某些渠道支付报错如：华为渠道
        payParams.setItemName("钻石");//购买物品名称
        payParams.setAmount(amount);//金额(分)
        payParams.setCount(1);//购买商品数量，例如50元宝，传值50
        payParams.setCallbackInfo("callbackInfo");//扩展信息，回调时原样返回,因为各渠道回调参数限制不一致。回调参数暂时只支持长度50。callBackInfo中不要使用这些符号：“|”、“=”、“+”、“/”。
        payParams.setCurrency("CNY");//国内可不传或CNY
        return payParams;
    }

    private void setText(String temp) {
        str = str + temp + "\n\n";
        textView.setText(str);
        Handler mHandler = new Handler();
        mHandler.postDelayed(new Runnable() {
            @Override
            public void run() {
                if (scrollView == null || linearLayout == null) {
                    return;
                }
                //end要显示的位置，可以根据自己的需要来计算
                int end = (linearLayout.getMeasuredHeight() - scrollView.getHeight());
                if (end < 0) {
                    end = 0;
                }
                scrollView.scrollTo(0, end);
            }
        }, 500);//延迟500ms启动
    }

    private void loginFirst() {
        ToastUtils.toast("请先登录");
    }
}