package com.hl.demo;

import android.app.Activity;
import android.app.AlertDialog;
import android.text.TextUtils;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import com.hoolai.access.open.fastaccess.channel.FastSdk;
import com.hoolai.access.open.fastaccess.channel.request.GoodsInfo;
import com.hoolai.access.open.fastaccess.channel.request.PayParams;
import com.hoolai.access.open.fastaccess.utils.ToastUtils;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.util.concurrent.ConcurrentHashMap;

public class ProductUtils {
    public static void showProducts(Activity activity, List<GoodsInfo> list){
        if (list == null || list.size() == 0) {
            ToastUtils.toast("商品信息获取为空");
            return;
        }
        AlertDialog.Builder builder = new AlertDialog.Builder(activity);
        AlertDialog dialog = builder.create();
        ListView listView = new ListView(activity);
        listView.setAdapter(new ArrayAdapter(activity, android.R.layout.simple_list_item_1, android.R.id.text1, list));
        listView.setOnItemClickListener((parent, view1, position, id) -> {
            GoodsInfo payInfo = list.get(position);
            // 游戏支付时需要传的参数 示例
            PayParams payParams = new PayParams();
            payParams.setItemId(payInfo.getItemId());
            payParams.setItemName(payInfo.getItemName());
            if (TextUtils.isEmpty(payInfo.getItemPrice())){
                payParams.setAmount(1);
            }else {
                payParams.setAmount(Integer.parseInt(payInfo.getItemPrice()));
            }
            if (TextUtils.isEmpty(payInfo.getItemCount())){
                payParams.setCount(1);
            }else{
                payParams.setCount(Integer.parseInt(payInfo.getItemCount()));
            }
            //扩展信息，回调时原样返回,因为各渠道回调参数限制不一致。回调参数暂时只支持长度50。callBackInfo中不要使用这些符号：“|”、“=”、“+”、“/”。
            payParams.setCallbackInfo("支付扩展信息,游戏透传参数"+ UUID.randomUUID().toString().replace("-",""));
            Map<String, String> map = new ConcurrentHashMap<>();
            map.put("isSupportThirdPayment", "true");//是否支持google之外的三方支付
            map.put("payType", "1");// 1 钱包(默认此类型) 2 点卡
            map.put("currency", "CNY");//币种
            payParams.setOpt(map);
            FastSdk.pay(payParams);
            dialog.dismiss();
        });
        dialog.setView(listView);
        dialog.show();
    }
}
